(define *reference-data-dir* ".")
(define (quick-save)
   (save-state)
   (map (lambda (imol) (write-pdb-file imol (molecule-name imol)))
      (model-molecule-list)
))
(define (fit-gap1 imol chain-id start-resno stop-resno . sequence)

        (if (not (valid-model-molecule? imol))
       
        (format #t "Molecule number ~s is not a valid model molecule" imol)

        (begin

          (let ((backup-mode (backup-state imol)))
            (make-backup imol)
            (turn-off-backup imol)

             ;; -----------------------------------------------
             ;; Make poly ala
             ;; -----------------------------------------------
           
            (set-terminal-residue-do-rigid-body-refine 0)
            (set-add-terminal-residue-n-phi-psi-trials 2000)
            (set-residue-selection-flash-frames-number 0)
            (let* ((immediate-refinement-mode
                    (refinement-immediate-replacement-state))
                   (direction (if (< stop-resno start-resno)
                                  'backwards
                                  'forwards))
                   (next-residue (if (eq? direction 'forwards) + -)))
              (format #t "direction is ~s~%" direction)
              (set-refinement-immediate-replacement 1)
              ;; recur over residues:
              ;(let f 
               (cond((residue-exists? imol chain-id stop-resno "")
                     (begin
                      (format #t "esite già ~s~%" stop-resno)
                       ))
                    (else
                (begin
                (format #t "~%~%add-terminal-residue: residue number: ~s~%~%" stop-resno)
                (let ((status (add-terminal-residue imol chain-id start-resno "ALA" 1)))
                  
                  (cond
                   ((= 1 status)
                                        ; first do a refinement of what we have
                    (refine-auto-range imol chain-id start-resno "")
                    (accept-regularizement))
                    
                   (else
                    (format #t "Failure in add terminal at residue ~s~%" start-resno)))))))
                ;( (format #t "esite già ~s~%" (next-residue resno 1))
                ; ( (if (< (next-residue resno 1) stop-resno)
                ;        ( (format #t "continua "))) 
                  ;        (f (next-residue resno 1)))
                  ;      (  (format #t "finito "))  )
                ;  (format #t "finito1 ")
                ;  )
                ;)
                 ; (format #t "finito2 "))   
                ;)   
              ;; -----------------------------------------------
              ;; From poly ala to sequence (if given):
              ;; -----------------------------------------------
              (format #t "mutation ~s~%" sequence)  
              (if (not (null? sequence))
                  (begin
                    (format #t "mutate-and-autofit-residue ~s ~S ~s ~s~%"
                            imol chain-id start-resno stop-resno (car sequence))
                    (mutate-and-autofit-residue-range imol chain-id
                                                      stop-resno stop-resno
                                                      (car sequence))))
              ;; -----------------------------------------------
              ;; Refine new zone
              ;; -----------------------------------------------
              (if (residue-exists? imol chain-id (- start-resno 1) "")
                  (format #t "Test finds~%")
                  (format #t "Test: not there~%"))

              (let* ((low-end (if (residue-exists? imol chain-id (- start-resno 1) "")
                                  (- start-resno 1)
                                  start-resno))
                     (high-end (if (residue-exists? imol chain-id (+ stop-resno 1) "")
                                   (+ stop-resno 1)
                                   stop-resno))
                     (final-zone (if (eq? direction 'forwards)
                                     (cons low-end high-end)
                                     (cons high-end low-end))))
                ;; we also need to check that start-resno-1 exists and
                ;; stop-resno+1 exists.
                (refine-zone imol chain-id (car final-zone) (cdr final-zone) "")
                                        ; set the refinement dialog flag back to what it was:
                (if (= immediate-refinement-mode 0)
                    (set-refinement-immediate-replacement 0))
                (accept-regularizement)))
            (if (= backup-mode 1)
                (turn-on-backup imol))))))

;;;; For Kay Diederichs, autofit without a map (find rotamer with best
;;;; clash score). This ignores alt conformations and residues with
;;;; insertion codes.
;;;;
(define de-clash
  (lambda (imol chain-id resno-start resno-end)

    (map (lambda (resno)
           (auto-fit-best-rotamer resno "" "" chain-id imol -1 1 0.1))
         (number-list resno-start resno-end))))

(define cs-file-name (append-dir-file *reference-data-dir* "cs.tab"))
(if(file-exists? cs-file-name)
 (call-with-input-file cs-file-name
  (lambda(port)
   (let loop ((voce (read port))
                    (all '()))
   (if (eof-object? voce)
    ((let (( pdb-1 (append-dir-file *reference-data-dir* (car all))))
      (let (( mtz-1 (append-dir-file *reference-data-dir* (cadr all))))
        (let ((pdb-mol (read-pdb pdb-1)))
         (sleep 1)
         (set-density-size 12.00)
;MTZ     (let ((map-mol (make-and-draw-map mtz-1 "F" "PHIMR" "WTMR" 0 0)))
;MAP     (let ((map-mol (handle-read-ccp4-map mtz-1 0)))
           (let ((lunghezza(length all)))
            (let loop2 (( n lunghezza))
             (if (= n 2)
               (  (quick-save)
                  (close-molecule pdb-mol)
                  (close-molecule map-mol)
                  ;(format #t "ho finito")
                  (coot-real-exit 0)
               )
               (
                (let (( chain-id (list-ref all (- n 4))))
                 (let (( resini (list-ref all (- n 3))))
                  (let (( resfin (list-ref all (- n 2))))
                  (let (( seq (list-ref all (- n 1))))
                      (turn-off-backup pdb-mol)
                      (fit-gap1 pdb-mol chain-id resini resfin seq)

                  ))))
                (loop2 (- n 4))))))))))
   )
   (loop (read port)(cons voce all) )
   )))))



