#! /bin/bash
let ncycles=cycdef
if [ $# -ge 1 ]
then
let ncycles=$1
fi
# prepare the mtz file to be used in the loop (ILM/ARP)  below
./cad_obs.sh

# run arp with the model from ILMILIONE
./arprun_model.sh > dea_arp0.log
 a=`fgrep 'Job ID is set to' dea_arp0.log | cut -c23-37`
 cp $a/dea_obs_warpNtrace.pdb $a/dea_arp_dedm_edm0_warpNtrace.pdb
./refmac_arp.sh $a 0 0
rm $a/dea_arp_dedm_edm0_warpNtrace.pdb
sirprot dea.sir >  dea_arp_dedm_edm0.out
cp dea_edm.mtz dea_arp_dedm_edm0.mtz

# loop ARP + DDM/EDM
# in the first cycle the mtz (with phases) from ILMILIONE is used.
let i=1
while [ $i -le $ncycles ]
do
   echo $i
    # ARP
    let ii=$i-1
   ./arprun_phases.sh $i $ii > dea_arp$i.log
    a=`fgrep 'Job ID is set to' dea_arp$i.log | cut -c23-37`
   ./refmac_arp.sh $a $i $ii
   # DEDM + EDM
   sirprot dea.sir >  dea_arp_dedm_edm$i.out
   cp dea_edm.mtz dea_arp_dedm_edm$i.mtz
   let i++
done
