#! /bin/bash
let ncycles=cycdef
if [ $# -ge 1 ]
then
let ncycles=$1
fi

# prepare the mtz file to be used in the loop (ILM/Phenix)
./cad_obs.sh

# run phenix with the model from ILMILIONE
./phenixrun_model.sh 
a=`tail -n1 dea_phenix0.log`
./refmac_phenix.sh $a 0
less $a/AutoBuild_run_*.log  >> dea_phenix0.log
sirprot dea.sir >  dea_phenix_dedm_edm0.out
cp dea_edm.mtz dea_phenix_dedm_edm0.mtz

# loop Phenix + DDM/EDM
let i=1
while [ $i -le $ncycles ]
do
   echo $i
    # Phenix
    let ii=$i-1
   ./phenixrun_phases.sh $i $ii
    a=`tail -n1 dea_phenix$i.log`
   ./refmac_phenix.sh $a $i
   less $a/AutoBuild_run_*.log  >> dea_phenix$i.log
   # DEDM + EDM
   sirprot dea.sir >  dea_phenix_dedm_edm$i.out
   cp dea_edm.mtz dea_phenix_dedm_edm$i.mtz
   let i++
done
