#! /bin/bash
let ncycles=cycdef
if [ $# -ge 1 ]
then
let ncycles=$1
fi

# prepare the mtz files to be used in the loop (ILM/Phenix)  below
./cad_obs.sh
./cad_phases.sh

# loop Phenix + DDM/EDM
# in the first cycle the mtz (with phases) from ILMILIONE is used.
let i=1
while [ $i -le $ncycles ]
do
   echo $i
    # Phenix
    let ii=$i-1
   ./phenixrun_phases.sh $i $ii
    a=`tail -n1 dea_phenix$i.log`
   ./refmac_phenix.sh $a $i
   less $a/AutoBuild_run_*.log  >> dea_phenix$i.log
   # DEDM + EDM
   sirprot dea.sir >  dea_phenix_dedm_edm$i.out
   cp dea_edm.mtz dea_phenix_dedm_edm$i.mtz
   let i++
done
